---
title: Multi-Select Dropdown
product: Form Library
description: SurveyJS Multi Selection Tag Box lets your users select several values from a drop-down list at once. View a free demo for JavaScript to learn how to create a multiple-choice dropdown in minutes.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/how-to-create-multiselect-tag-box/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Multi-Select Dropdown (Vanilla JS)

Tag Box questions allow respondents to select multiple values from a drop-down list. Selected items are displayed in the input field as removable tags. This example shows how to add a multiple-selection dropdown with a search option to your survey.

## Create a Tag Box Question

To create a [Tag Box](https://surveyjs.io/form-library/documentation/questiontagboxmodel) question, define an object with the `type` property set to `"tagbox"` and add it to the [`elements`](https://surveyjs.io/form-library/documentation/pagemodel#elements) array. Use the [`choices`](https://surveyjs.io/form-library/documentation/questiontagboxmodel#choices) array to specify drop-down list items. This array can contain either of the following:

- String values
  
  ```js
  "choices": [ "Option 1", "Option 2", "Option 3" ] 
  ```

- Objects with the `text` (display value) and `value` (value to be saved in survey results) properties

  ```js
  "choices": [{
    "text": "Option 1", 
    "value": 1
  }, {
    "text": "Option 2",
    "value": 2
  }, {
    "text": "Option 3",
    "value": 3
  }] 
  ```

If you want to load choice values from a RESTful service as shown in this example, use the [`choicesByUrl`](https://surveyjs.io/form-library/documentation/questiontagboxmodel#choicesByUrl) property instead. It accepts an object that configures access to the web service. This demo specifies only the service's URL. Refer to the [ChoicesRestful](https://surveyjs.io/form-library/documentation/choicesrestful) object for more information on how to configure the `choicesByUrl` property.

## Configure Search

Respondents can search in the drop-down list to find the item they are looking for. Enter a text string right into the input field to try this functionality. If you want to disable search, assign `false` to the [`searchEnabled`](https://surveyjs.io/form-library/documentation/questiontagboxmodel#searchEnabled) property.

## Hide Selected Items

Selected items are added to the input field as tags. However, they also remain highlighted in the drop-down list. If you want selected items to be removed from the list, enable the [`hideSelectedItems`](https://surveyjs.io/form-library/documentation/questiontagboxmodel#hideSelectedItems) property. This example demonstrates the default behavior.

## Implement a Custom Item Template

If you want to customize drop-down list items, create and apply a custom item template. Since Tag Box shares this functionality with the Dropdown question, refer to the following Dropdown demo for detailed instructions: [Dropdown with Custom Item Template](https://surveyjs.io/form-library/examples/questiontype-dropdown-itemtemplate/).

## See Also

[Conditionally Display Choice Options](/form-library/examples/how-to-conditionally-display-choice-options/ (linkStyle))

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});

survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "elements": [
    {
      "type": "tagbox",
      "isRequired": true,
      "choicesByUrl": {
        "url": "https://surveyjs.io/api/CountriesExample"
      },
      "name": "countries",
      "title": "Which countries have you visited within the last three years?",
      "description": "Please select all that apply."
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/how-to-create-multiselect-tag-box/angular.md)
- [React](https://surveyjs.io/form-library/examples/how-to-create-multiselect-tag-box/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/how-to-create-multiselect-tag-box/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/how-to-create-multiselect-tag-box/jquery.md)


---
title: Multi-Select Dropdown
product: Form Library
description: SurveyJS Multi Selection Tag Box lets your users select several values from a drop-down list at once. View a free demo for JavaScript to learn how to create a multiple-choice dropdown in minutes.
framework: React
source: https://surveyjs.io/form-library/examples/how-to-create-multiselect-tag-box/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Multi-Select Dropdown (React)

Tag Box questions allow respondents to select multiple values from a drop-down list. Selected items are displayed in the input field as removable tags. This example shows how to add a multiple-selection dropdown with a search option to your survey.

## Create a Tag Box Question

To create a [Tag Box](https://surveyjs.io/form-library/documentation/questiontagboxmodel) question, define an object with the `type` property set to `"tagbox"` and add it to the [`elements`](https://surveyjs.io/form-library/documentation/pagemodel#elements) array. Use the [`choices`](https://surveyjs.io/form-library/documentation/questiontagboxmodel#choices) array to specify drop-down list items. This array can contain either of the following:

- String values
  
  ```js
  "choices": [ "Option 1", "Option 2", "Option 3" ] 
  ```

- Objects with the `text` (display value) and `value` (value to be saved in survey results) properties

  ```js
  "choices": [{
    "text": "Option 1", 
    "value": 1
  }, {
    "text": "Option 2",
    "value": 2
  }, {
    "text": "Option 3",
    "value": 3
  }] 
  ```

If you want to load choice values from a RESTful service as shown in this example, use the [`choicesByUrl`](https://surveyjs.io/form-library/documentation/questiontagboxmodel#choicesByUrl) property instead. It accepts an object that configures access to the web service. This demo specifies only the service's URL. Refer to the [ChoicesRestful](https://surveyjs.io/form-library/documentation/choicesrestful) object for more information on how to configure the `choicesByUrl` property.

## Configure Search

Respondents can search in the drop-down list to find the item they are looking for. Enter a text string right into the input field to try this functionality. If you want to disable search, assign `false` to the [`searchEnabled`](https://surveyjs.io/form-library/documentation/questiontagboxmodel#searchEnabled) property.

## Hide Selected Items

Selected items are added to the input field as tags. However, they also remain highlighted in the drop-down list. If you want selected items to be removed from the list, enable the [`hideSelectedItems`](https://surveyjs.io/form-library/documentation/questiontagboxmodel#hideSelectedItems) property. This example demonstrates the default behavior.

## Implement a Custom Item Template

If you want to customize drop-down list items, create and apply a custom item template. Since Tag Box shares this functionality with the Dropdown question, refer to the following Dropdown demo for detailed instructions: [Dropdown with Custom Item Template](https://surveyjs.io/form-library/examples/questiontype-dropdown-itemtemplate/).

## See Also

[Conditionally Display Choice Options](/form-library/examples/how-to-conditionally-display-choice-options/ (linkStyle))

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "elements": [
    {
      "type": "tagbox",
      "isRequired": true,
      "choicesByUrl": {
        "url": "https://surveyjs.io/api/CountriesExample"
      },
      "name": "countries",
      "title": "Which countries have you visited within the last three years?",
      "description": "Please select all that apply."
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/how-to-create-multiselect-tag-box/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/how-to-create-multiselect-tag-box/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/how-to-create-multiselect-tag-box/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/how-to-create-multiselect-tag-box/vanillajs.md)


---
title: Multi-Select Dropdown
product: Form Library
description: SurveyJS Multi Selection Tag Box lets your users select several values from a drop-down list at once. View a free demo for JavaScript to learn how to create a multiple-choice dropdown in minutes.
framework: Angular
source: https://surveyjs.io/form-library/examples/how-to-create-multiselect-tag-box/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Multi-Select Dropdown (Angular)

Tag Box questions allow respondents to select multiple values from a drop-down list. Selected items are displayed in the input field as removable tags. This example shows how to add a multiple-selection dropdown with a search option to your survey.

## Create a Tag Box Question

To create a [Tag Box](https://surveyjs.io/form-library/documentation/questiontagboxmodel) question, define an object with the `type` property set to `"tagbox"` and add it to the [`elements`](https://surveyjs.io/form-library/documentation/pagemodel#elements) array. Use the [`choices`](https://surveyjs.io/form-library/documentation/questiontagboxmodel#choices) array to specify drop-down list items. This array can contain either of the following:

- String values
  
  ```js
  "choices": [ "Option 1", "Option 2", "Option 3" ] 
  ```

- Objects with the `text` (display value) and `value` (value to be saved in survey results) properties

  ```js
  "choices": [{
    "text": "Option 1", 
    "value": 1
  }, {
    "text": "Option 2",
    "value": 2
  }, {
    "text": "Option 3",
    "value": 3
  }] 
  ```

If you want to load choice values from a RESTful service as shown in this example, use the [`choicesByUrl`](https://surveyjs.io/form-library/documentation/questiontagboxmodel#choicesByUrl) property instead. It accepts an object that configures access to the web service. This demo specifies only the service's URL. Refer to the [ChoicesRestful](https://surveyjs.io/form-library/documentation/choicesrestful) object for more information on how to configure the `choicesByUrl` property.

## Configure Search

Respondents can search in the drop-down list to find the item they are looking for. Enter a text string right into the input field to try this functionality. If you want to disable search, assign `false` to the [`searchEnabled`](https://surveyjs.io/form-library/documentation/questiontagboxmodel#searchEnabled) property.

## Hide Selected Items

Selected items are added to the input field as tags. However, they also remain highlighted in the drop-down list. If you want selected items to be removed from the list, enable the [`hideSelectedItems`](https://surveyjs.io/form-library/documentation/questiontagboxmodel#hideSelectedItems) property. This example demonstrates the default behavior.

## Implement a Custom Item Template

If you want to customize drop-down list items, create and apply a custom item template. Since Tag Box shares this functionality with the Dropdown question, refer to the following Dropdown demo for detailed instructions: [Dropdown with Custom Item Template](https://surveyjs.io/form-library/examples/questiontype-dropdown-itemtemplate/).

## See Also

[Conditionally Display Choice Options](/form-library/examples/how-to-conditionally-display-choice-options/ (linkStyle))

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "elements": [
    {
      "type": "tagbox",
      "isRequired": true,
      "choicesByUrl": {
        "url": "https://surveyjs.io/api/CountriesExample"
      },
      "name": "countries",
      "title": "Which countries have you visited within the last three years?",
      "description": "Please select all that apply."
    }
  ]
};
```

### `src/app/components/survey.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add your custom CSS here. */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/how-to-create-multiselect-tag-box/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/how-to-create-multiselect-tag-box/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/how-to-create-multiselect-tag-box/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/how-to-create-multiselect-tag-box/vanillajs.md)
